#include <SPI.h>

#include <Ethernet.h>

#include <RFID.h>

#define SS_PIN 6
#define RST_PIN 9
#define inputPin 14
#define outputPin 19
int count = 0;
int lastCount = 0;
RFID rfid(SS_PIN, RST_PIN);

byte mac[] = {
  0xDE,
  0xAD,
  0xBE,
  0xEF,
  0xFE,
  0xED
};
String rfidCard;
IPAddress server(192, 168, 2, 234);

IPAddress ip(192, 168, 2, 197);
EthernetServer webServer(80);
String lastIn;
String lastOut;
EthernetClient client;

void setup() {
  Serial.begin(9600);
  pinMode(inputPin, INPUT);
  pinMode(outputPin, INPUT);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
 
  SPI.begin();
  rfid.init();
  Serial.println("Initialize Ethernet with DHCP:");
  if (Ethernet.begin(mac) == 0) {
    Serial.println("Failed to configure Ethernet using DHCP");

    if (Ethernet.hardwareStatus() == EthernetNoHardware) {
      Serial.println("Ethernet shield was not found.  Sorry, can't run without hardware. :(");
      while (true) {
        delay(1); // do nothing, no point running without Ethernet hardware
      }
    }
    if (Ethernet.linkStatus() == LinkOFF) {
      Serial.println("Ethernet cable is not connected.");
    }
    Ethernet.begin(mac, ip);
    Serial.println("aici");
    webServer.begin( );
  } else {
    Serial.print("  DHCP assigned IP ");
    Serial.println(Ethernet.localIP());
    Ethernet.begin(mac, ip);
    webServer.begin( );
  }
   
  delay(1000);
  
}

void loop() {
  // if there are incoming bytes available
  // from the server, read them and print them:
   EthernetClient webClient = webServer.available();
    if(webClient) {
    while(webClient.connected()){
      if(webClient.available()) {
          webClient.println ("HTTP/1.1 200 OK");
          webClient.println ("Content-Type: text/html");
          webClient.println ("Connection: close");
          webClient.println ("Refresh: 5");
          webClient.println ( );
          webClient.println ("<!DOCTYPE HTML>");
          webClient.println ("<html>");
          webClient.print ("<Title>Arduino visitor counter webserver </Title>");
          webClient.print ("<h1>Numarul de persoane este :  ");
          webClient.print (count);
          webClient.print ("</h1>");  
          webClient.println ("</html>");
          break;      
      }
    }
    delay(1);
    webClient.stop();
  }
  if (digitalRead(inputPin) == LOW) {
    if (rfid.isCard()) {
      if (rfid.readCardSerial()) {
        rfidCard = String(rfid.serNum[0]) + String(rfid.serNum[1]) + String(rfid.serNum[2]) + String(rfid.serNum[3]);
        if (client.connect(server, 8080)) {
          String message = "GET /verify?id=" + rfidCard + " HTTP/1.1";
          client.println(message);
          client.println("Host: 192.168.2.234");
          client.println("Connection: close");
          client.println();
        }
        Serial.println();
        Serial.println();
        Serial.println("Scanare cartela...");
        delay(500);
        while (client.connected() && !client.available()) delay(1); //waits for data
        int len = 199;
        String s = "";
        while (client.connected() || client.available()) { //connected or data available
          char c = client.read(); //gets byte from ethernet buffer

          if (len == 0) {
            s += c;
          } else {
            len--;
          }
        }
        int n = s.length();
        char char_array[n + 1];
        strcpy(char_array, s.c_str());
        if (!strncmp(char_array, "Not authorized", 15)) {
          Serial.println(s);
        } else {
          Serial.println(s);
          Serial.println();
          Serial.println();
          client.stop();
          count++;
        }
      }
      rfid.halt();
    }

  }

  if (digitalRead(outputPin) == LOW) {
    if (rfid.isCard()) {
      if (rfid.readCardSerial()) {
        rfidCard = String(rfid.serNum[0]) + String(rfid.serNum[1]) + String(rfid.serNum[2]) + String(rfid.serNum[3]);
        int len = rfidCard.length();
        char copie[len];
        int lenLastOut = lastOut.length();
        char copieLastOut[lenLastOut];
        
        strcpy(copie, rfidCard.c_str());
        strcpy(copieLastOut, lastOut.c_str());
        
        if (len != lenLastOut || strcmp(copieLastOut, copie) == 1) {
          if (client.connect(server, 8080)) {
            String message = "GET /leave?id=" + rfidCard + " HTTP/1.1";
            client.println(message);
            client.println("Host: 192.168.2.234");
            client.println("Connection: close");
            client.println();
          }
          count --;
          if( count < 0) {
            count = 0;
          }
        }
        lastOut = String(rfidCard);
      }
    }
  }

}
